/*
 *  ngtk/c/ngtk_bars.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the 
    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
    Boston, MA  02111-1307  USA.

----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>

void ngtk_footbar(int cpair1, int attr1, int cpair2, int attr2)
{
    int i;

    foot_bar = ngtk_push_win(1, COLS, LINES-1, 0, cpair1, attr1, 0, 0);
    ngtk_clrwin(foot_bar->win, 32, 1);
    waddch(foot_bar->win, 32);

    for (i=0;i<=t_bar-1;i++) {
        wattrset(foot_bar->win, COLOR_PAIR(cpair1) | attr1);
        wprintw(foot_bar->win, " %s", t_bar1[i]);
        wattrset(foot_bar->win, COLOR_PAIR(cpair2) | attr2);
        wprintw(foot_bar->win, " %s ", t_bar2[i]);
    }
    wnoutrefresh(foot_bar->win);
}

void ngtk_topbar(int cpair, int attr, char *msg, int init)
{
    if (init == 1)
        top_bar = ngtk_push_win(1, COLS, 0, 0, cpair, attr, 0, 0);
    else
        ngtk_pull_win(top_bar);

    ngtk_clrwin(top_bar->win, 32, 1);
    waddstr(top_bar->win, msg);
    wrefresh(top_bar->win);
}
