/*
 *  ngtk/c/ngtk_yesno.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the 
 *  Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 *  Boston, MA  02111-1307  USA.
 *
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>


int ngtk_yesnobox(int height, int width, int top, int left, int cpair,
				  int attr, char *title, char *prompt, int def_val)
{
    int xyes, xno;
	int yitems;
    int buf = 0;
    int rt_val = def_val;
	ngtk_win_t *box;

    xyes = (width/4)-1;
    xno = (width/2)+(width/4)-1;

	yitems = height - 4;
    box = ngtk_mkbox(height, width, top, left, cpair, attr, title, 0, 1, 0);
    mvwaddstr(box->win, 2, (width/2)-(strlen(prompt)/2), prompt);
    mvwaddstr(box->win, yitems+1, xyes, "Yes");
    mvwaddstr(box->win, yitems+1, xno, "No");
    if (!def_val)
        ngtk_minibox(box, 3, 3, yitems, xno-1, 1, 0, 1);
    else
        ngtk_minibox(box, 3, 4, yitems, xyes-1, 1, 0, 1);

    while (buf != CR) {
		buf = ngtk_get_keysym();

        switch(buf) {
            case NGTK_KEY_LEFT:
				if (!rt_val)
                   	rt_val++;
				else
					rt_val--;
				ngtk_minibox(box, 3, 3, yitems, xno-1, !rt_val, 0, 0);
                ngtk_minibox(box, 3, 4, yitems, xyes-1, rt_val, 0, 1);
                break;

            case NGTK_KEY_RIGHT:
				if (!rt_val)
					rt_val++;
				else
   					rt_val--;
                ngtk_minibox(box, 3, 4, yitems, xyes-1, rt_val, 0, 0);
                ngtk_minibox(box, 3, 3, yitems, xno-1, !rt_val, 0, 1);
                break;

			case ESC:
                ngtk_pop_win(box);
				return(-1);

			case 'Y':
			case 'y':
				ngtk_pop_win(box);
				return(1);

			case 'N':
			case 'n':
				ngtk_pop_win(box);
				return(0);

            default:
                break;
        }
    }

    ngtk_pop_win(box);
    return(rt_val);
}



int ngtk_auto_pos_yesnobox(int height, int width, int cpair, int attr,
						   char *title, char *prompt, int def_val)
{
    int top = (LINES/2) - (height/2);
    int left = (COLS/2) - (width/2);

    return(ngtk_yesnobox(height, width, top, left, cpair, attr, title, prompt,
						 def_val));
}

int ngtk_auto_size_yesnobox(int top, int left, int cpair, int attr,
							char *title, char *prompt, int def_val)
{
    int sprompt = strlen(prompt) + 4;
    int height = 7;
    int width;

    if (sprompt > 25)
        width = sprompt;
    else
        width = 25;

    return(ngtk_yesnobox(height, width, top, left, cpair, attr, title, prompt,
						 def_val));
}

int ngtk_auto_yesnobox(int cpair, int attr, char *title, char *prompt,
					   int def_val)
{
    int sprompt = strlen(prompt) + 4;
    int height = 7;
    int top = (LINES/2) - (height/2);
    int width;
    int left;

    if (sprompt > 25)
        width = sprompt;
    else
        width = 25;
    left = (COLS/2) - (width/2);

    return(ngtk_yesnobox(height, width, top, left, cpair, attr, title, prompt,
						 def_val));
}
